码迷,mamicode.com
首页 > 编程语言 > 详细

hdu 3605 Escape 二分图的多重匹配(匈牙利算法)

时间:2016-02-06 22:25:21      阅读:303      评论:0      收藏:0      [点我收藏+]

标签:

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3605

Escape

Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 8001    Accepted Submission(s): 1758


Problem Description
2012 If this is the end of the world how to do? I do not know how. But now scientists have found that some stars, who can live, but some people do not fit to live some of the planet. Now scientists want your help, is to determine what all of people can live in these planets.
 

Input
More set of test data, the beginning of each data is n (1 <= n <= 100000), m (1 <= m <= 10) n indicate there n people on the earth, m representatives m planet, planet and people labels are from 0. Here are n lines, each line represents a suitable living conditions of people, each row has m digits, the ith digits is 1, said that a person is fit to live in the ith-planet, or is 0 for this person is not suitable for living in the ith planet.
The last line has m digits, the ith digit ai indicates the ith planet can contain ai people most..
0 <= ai <= 100000
 

Output
Determine whether all people can live up to these stars
If you can output YES, otherwise output NO.
 

Sample Input
1 1 1 1 2 2 1 0 1 0 1 1
 

Sample Output
YES NO
 

Source

题目大意: N(N<100,000)个人要去M(M<10)个星球,每个人只可以去一些星球,一个星球最多容纳Ki个人,输出是否所有人都可以选择自己的星球。
解题思路:放置了很久的题目了,一直是TLE,今天翻出来改来改去还是TLE~~~~技术分享大过年的,非要AC。
由于n很大,m很小,标记的数组不要太大,15就足够啦。解决多重匹配就是记录一下多重匹配的点(简称Y方点)已经匹配了Pi个点。如果Pi<Ki那么就直接上了,否则的话继续搜索Yi已经匹配的每一个点并将Yi染色,因为Yi搜一次就需要染色了,而且Y方点最多是10个,所以每次找增广路的深度最多是10,这样就很快了!!!技术分享(用c++交吧)

详见代码。
#include <iostream>
#include <cstdio>
#include <cstring>

using namespace std;

int n,m;
int w[15],cnt[15];
int Map[100010][12],mat[12][100010];
bool vis[15];

bool Find(int x)
{
	for(int i=0;i<m;i++)
		if(!vis[i]&&Map[x][i])
		{
			vis[i]=1;
			if(cnt[i]<w[i])
			{
				mat[i][cnt[i]++]=x;
				return true;
			}
			for(int j=0;j<cnt[i];j++)
				if(Find(mat[i][j]))
				{
					mat[i][j]=x;
					return true;
				}
		}
	return false;
}

bool ok()
{
	memset(cnt,0,sizeof(cnt));
	for(int i=0;i<n;i++)
	{
		memset(vis,0,sizeof(vis));
		if(!Find(i))
			return false;
	}
	return true;
}

int main()
{
	while(~scanf("%d%d",&n,&m))
	{
		for(int i=0;i<n;i++)
			for(int j=0;j<m;j++)
				scanf("%d",&Map[i][j]);
		for(int i=0;i<m;i++)
			scanf("%d",&w[i]);
        if (ok()==1)
            printf ("YES\n");
        else
            printf ("NO\n");
	}
	return 0;
}




hdu 3605 Escape 二分图的多重匹配(匈牙利算法)

标签:

原文地址:http://blog.csdn.net/qiqi_skystar/article/details/50640724

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!